<?php
/*
*
* JetBackup @ package
* Created By Idan Ben-Ezra
*
* Copyrights @ JetApps LLC
* https://www.jetapps.com
*
**/

pm_Context::init('jetbackup5');
$client = pm_Session::getClient();

$login_as = '';
if($_REQUEST['dom_id']) {
	$domain = pm_Domain::getByDomainId($_REQUEST['dom_id']);
	if(!$client->hasPermission('manage_jetbackup', $domain)) throw new pm_Exception('Permission denied');
	$username = $domain->getSysUserLogin();
} elseif($client->isAdmin()) {
	$username = 'root';
} elseif($client->hasPermission('manage_jetbackup')) {
	$username = 'root';
	$login_as = $client->getLogin();
} else {
	throw new pm_Exception('Permission denied');
}

$data = [];
$input = file_get_contents('php://input');
if($input) $data = array_merge($data, json_decode($input, true));
if(isset($_REQUEST)) $data = array_merge($data, $_REQUEST);
$data['panel_locale'] = $client->getProperty('locale');
$data['login_as'] = $login_as;

$output = pm_ApiCli::callSbin("jetbackupadmin", [$username, json_encode($data)], pm_ApiCli::RESULT_EXCEPTION, [
	'SERVER_SOFTWARE' => '',
	'GATEWAY_INTERFACE' => '',
	'REQUEST_METHOD' => '',
]);
if($output['code']) throw new pm_Exception("Failed loading JetBackup. Error: {$output['stderr']}");


$headers_length = 0;
$data_length = strlen($output['stdout']);

for($i = 0; $i < $data_length; $i++) {
	if(substr($output['stdout'], $i, 4) != "\r\n\r\n") continue;
	$headers_length = $i;
	break;
}

$separator = "\r\n";
$headers = substr($output['stdout'], 0, $headers_length);
$line = strtok($headers, $separator);

while ($line !== false) {
	header($line);
	$line = strtok( $separator );
}

echo substr($output['stdout'], $headers_length+4);

?>
